// cbmc --trace --function check 1.c

#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <inttypes.h>

/*
 * Name: crc-64-jones
 * Width: 64 bites
 * Poly: 0xad93d23594c935a9
 * Reflected In: True
 * Xor_In: 0xffffffffffffffff
 * Reflected_Out: True
 * Xor_Out: 0x0
 * Check("123456789"): 0xe9c6d914c4b8d9ca
 */
// works as in: https://github.com/codeaholics/node-rdb-tools/blob/master/src/crc-64-jones.c
uint64_t CRC64_jones(uint64_t crc, uint8_t *buf, size_t len)
{
        crc=0;
        while (len--)
        {
                crc ^= *buf;
                buf++;
                for (int k = 0; k < 8; k++)
                        crc = crc & 1UL ? (crc >> 1) ^ 0x95ac9329ac4bc9b5 : crc >> 1; // reversed poly
        }
        return crc;
}

//#define STR "lorem ipsum "
#define STRLEN 12
#define HASH 0xe7330951e3dc68f4

void check()
{
        char buf[STRLEN+1];
        buf[STRLEN]=0;
        int string_correct=1;
        for (int i=0; i<STRLEN; i++)
        {
                uint8_t t=buf[i];
                int char_correct=(t==' ' || (t>='a' && t<='z'));
                if (!char_correct)
                        string_correct=0;
        };
        if (string_correct)
        {
                assert (CRC64_jones(0, buf, STRLEN)!=HASH);
        };
};

int main()
{
};   

